"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const static_1 = __importDefault(require("@fastify/static"));
const fastify_plugin_1 = __importDefault(require("fastify-plugin"));
const fs_1 = require("fs");
const promises_1 = __importStar(require("fs/promises"));
const path_1 = require("path");
const yaml_1 = require("yaml");
const storagePath = (0, path_1.resolve)(__dirname, '../storage');
const indexTemplatePath = (0, path_1.resolve)(storagePath, 'index.html');
async function fastifyServeStoplight(fastify, { appName, path, prefix: globalPrefix = '/docs/api', cachePath = (0, path_1.resolve)(storagePath, 'cache') }, next) {
    const cleanPrefix = `${globalPrefix}/`.replace(/([\\/]+)/g, '/');
    const versions = await promises_1.default.readdir(path);
    await Promise.all(versions.map(async (version) => {
        const title = `${appName} ${version}`;
        const root = (0, path_1.resolve)(path, version);
        const prefix = cleanPrefix + version;
        fastify.register(static_1.default, {
            root,
            prefix,
            decorateReply: false,
        });
        const indexTemplate = await promises_1.default.readFile(indexTemplatePath, 'utf-8');
        let indexHtml = indexTemplate.replace(/{{ title }}/g, title);
        indexHtml = indexHtml.replace(/{{ schemaUrl }}/g, `${version}/index.yaml`);
        const cacheRoot = (0, path_1.resolve)(cachePath, version);
        await (0, promises_1.mkdir)(cacheRoot, { recursive: true });
        const cacheIndexHtml = (0, path_1.resolve)(cacheRoot, 'index.html');
        const cacheIndexYaml = (0, path_1.resolve)(cacheRoot, 'index.yaml');
        const indexYamlContent = await promises_1.default.readFile((0, path_1.resolve)(root, 'index.yaml'), 'utf-8');
        const indexYamlObj = (0, yaml_1.parse)(indexYamlContent);
        indexYamlObj.info = {
            ...indexYamlObj.info,
            title,
        };
        const newYamlContent = (0, yaml_1.stringify)(indexYamlObj);
        await Promise.all([promises_1.default.writeFile(cacheIndexYaml, newYamlContent), promises_1.default.writeFile(cacheIndexHtml, indexHtml)]);
        // /docs/api/v1 -> storage/cache/v1/index.html
        fastify.get(prefix, async (_, res) => res
            .send((0, fs_1.createReadStream)(cacheIndexHtml))
            .header('Content-Type', 'text/html')
            .header('Content-Security-Policy', undefined)
            .header('Cross-Origin-Embedder-Policy', undefined)
            .header('Cross-Origin-Opener-Policy', undefined)
            .header('Cross-Origin-Resource-Policy', undefined));
        // /docs/api/v1/index.yaml -> storage/cache/v1/index.yaml
        fastify.get(`${prefix}/index.yaml`, async (_, res) => {
            const content = await promises_1.default.readFile(cacheIndexYaml, 'utf-8');
            return res
                .send(content)
                .header('Content-Type', 'application/octet-stream')
                .header('Content-Security-Policy', undefined)
                .header('Cross-Origin-Embedder-Policy', undefined)
                .header('Cross-Origin-Opener-Policy', undefined)
                .header('Cross-Origin-Resource-Policy', undefined);
        });
    }));
    next();
}
const plugin = (0, fastify_plugin_1.default)(fastifyServeStoplight, {
    fastify: '4.x',
    name: 'fastify-server-stoplight',
});
exports.default = plugin;
